aubio: spectral/filterbank_mel.h File Reference

aubio 0.4.9

Functions
filterbank_mel.h File Reference

Filterbank object coefficients initialization. More...

Go to the source code of this file.

## Functions
uint_t | aubio_filterbank_set_triangle_bands (aubio_filterbank_t *fb, const fvec_t *freqs, smpl_t samplerate)
| filterbank initialization with triangular and overlapping bands More...
uint_t | aubio_filterbank_set_mel_coeffs_slaney (aubio_filterbank_t *fb, smpl_t samplerate)
| filterbank initialization for Mel filters using Slaney's coefficients More...
uint_t | aubio_filterbank_set_mel_coeffs (aubio_filterbank_t *fb, smpl_t samplerate, smpl_t fmin, smpl_t fmax)
| Mel filterbank initialization. More...
uint_t | aubio_filterbank_set_mel_coeffs_htk (aubio_filterbank_t *fb, smpl_t samplerate, smpl_t fmin, smpl_t fmax)
| Mel filterbank initialization. More...

## Detailed Description

Filterbank object coefficients initialization.

Functions to create set the aubio_filterbank_t coefficients to

- aubio_filterbank_set_triangle_bands: overlapping triangular bands,
- aubio_filterbank_set_mel_coeffs_slaney: Mel frequency bands.

Definition in file filterbank_mel.h.

## Function Documentation

## ◆ aubio_filterbank_set_mel_coeffs()

uint_t aubio_filterbank_set_mel_coeffs | ( | aubio_filterbank_t * | fb,
|  | smpl_t | samplerate,
|  | smpl_t | fmin,
|  | smpl_t | fmax
| ) |  |

Mel filterbank initialization.

Parameters

  fb | filterbank object
  samplerate | audio sampling rate
  fmin | start frequency, in Hz
  fmax | end frequency, in Hz

The filterbank will be initialized with bands linearly spaced in the mel scale, from `fmin` to `fmax`.

## References

Malcolm Slaney, Auditory Toolbox Version 2, Technical Report #1998-010 https://engineering.purdue.edu/~malcolm/interval/1998-010/

## ◆ aubio_filterbank_set_mel_coeffs_htk()

uint_t aubio_filterbank_set_mel_coeffs_htk | ( | aubio_filterbank_t * | fb,
|  | smpl_t | samplerate,
|  | smpl_t | fmin,
|  | smpl_t | fmax
| ) |  |

Mel filterbank initialization.

Parameters

  fb | filterbank object
  samplerate | audio sampling rate
  fmin | start frequency, in Hz
  fmax | end frequency, in Hz

The bank of filters will be initalized to to cover linearly spaced bands in the Htk mel scale, from `fmin` to `fmax`.

## References

Douglas O'Shaughnessy (1987). Speech communication: human and machine. Addison-Wesley. p. 150. ISBN 978-0-201-16520-3.

HTK Speech Recognition Toolkit: http://htk.eng.cam.ac.uk/

## ◆ aubio_filterbank_set_mel_coeffs_slaney()

uint_t aubio_filterbank_set_mel_coeffs_slaney | ( | aubio_filterbank_t * | fb,
|  | smpl_t | samplerate
| ) |  |

filterbank initialization for Mel filters using Slaney's coefficients

Parameters

  fb | filterbank object
  samplerate | audio sampling rate, in Hz

The filter coefficients are built to match exactly Malcolm Slaney's Auditory Toolbox implementation (see file mfcc.m). The number of filters should be 40.

## References

Malcolm Slaney, Auditory Toolbox Version 2, Technical Report #1998-010 https://engineering.purdue.edu/~malcolm/interval/1998-010/

Examples
  spectral/test-filterbank_mel.c.

## ◆ aubio_filterbank_set_triangle_bands()

uint_t aubio_filterbank_set_triangle_bands | ( | aubio_filterbank_t * | fb,
|  | const fvec_t * | freqs,
|  | smpl_t | samplerate
| ) |  |

filterbank initialization with triangular and overlapping bands

Parameters

  fb | filterbank object
  freqs | arbitrary array of boundary frequencies
  samplerate | audio sampling rate

This function computes the coefficients of the filterbank based on the boundaries found in freqs, in Hz, and using triangular overlapping bands.